# This file is a fix of fe19119_mul-1.q and fe19119_mul-2.q.
# The bug of fe19119_mul-1.q and fe19119_mul-2.q is not in the released version.

# CPU: Intel(R) Xeon(R) CPU X5675 @ 3.07GHz
# RAM: 32GB
# Configuration: -c consts -s
# With Boolector 1.6.0 (-minisat): 8m43.071s

int64 r0
int64 r1
int64 r2
int64 r3

#stack64 caller_r11_stack
#stack64 caller_r12_stack
#stack64 caller_r13_stack
#stack64 caller_r14_stack
#stack64 caller_r15_stack
#stack64 caller_rbx_stack
#stack64 caller_rbp_stack

int64 r4
int64 r5
int64 r6
int64 rax
int64 rdx
int64 x0
int64 x1
int64 x2
int64 x3
int64 c
int64 zero
int64 i38

enter fe19119_mul

###################################################################
# Conditions on the inputs: x0 = *(uint64 *)(input_1 +  0),
#                           x1 = *(uint64 *)(input_1 +  8),
#                           x2 = *(uint64 *)(input_1 + 16),
#                           y0 = *(uint64 *)(input_2 +  0),
#                           y1 = *(uint64 *)(input_2 +  8),
#                           y2 = *(uint64 *)(input_2 + 16) are all arbitrary 64-bit unsigned integers 
#
###################################################################


#caller_r11_stack = caller_r11
#caller_r12_stack = caller_r12
#caller_r13_stack = caller_r13
#caller_r14_stack = caller_r14
#caller_r15_stack = caller_r15
#caller_rbx_stack = caller_rbx
#caller_rbp_stack = caller_rbp

input_2 = input_2

  r3 = 0
  r4 = 0
  r5 = 0
  
  x0 = *(uint64 *)(input_1 + 0)
  rax = *(uint64 *)(input_2 + 0)
  (uint128) rdx rax = rax * x0
  r0 = rax
  r1 = rdx
  
  rax = *(uint64 *)(input_2 + 8)
  (uint128) rdx rax = rax * x0
  carry? r1 += rax
  r2 = 0
  r2 += rdx + carry
  
  rax = *(uint64 *)(input_2 + 16)
  (uint128) rdx rax = rax * x0
  carry? r2 += rax
  r3 = 0
  r3 += rdx + carry

  #// var A0 = (input_1[0]@u128 * input_2[0]@u128)@u384 + (input_1[0]@u128 * input_2[8]@u128)@u384 * 2**64 + (input_1[0]@u128 * input_2[16]@u128)@u384 * 2**128
  #// cut r4 = 0 && r5 = 0 &&
  #//     A0 = (input_1[0]@u128 * input_2[0]@u128)@u384 + (input_1[0]@u128 * input_2[8]@u128)@u384 * 2**64 + (input_1[0]@u128 * input_2[16]@u128)@u384 * 2**128 &&
  #//     r0@u384 + r1@u384 * 2**64 + r2@u384 * 2**128 + r3@u384 * 2**192 = A0
  
  x1 = *(uint64 *)(input_1 + 8)
  rax = *(uint64 *)(input_2 + 0)
  (uint128) rdx rax = rax * x1
  carry? r1 += rax
  c = 0
  c += rdx + carry

  #// var B0 = A0 + (input_1[8]@u128 * input_2[0]@u128)@u384 * 2**64
  #// cut r4 = 0 && r5 = 0 && x1 = input_1[8] &&
  #//     A0 = (input_1[0]@u128 * input_2[0]@u128)@u384 + (input_1[0]@u128 * input_2[8]@u128)@u384 * 2**64 + (input_1[0]@u128 * input_2[16]@u128)@u384 * 2**128 &&
  #//     B0 = A0 + (input_1[8]@u128 * input_2[0]@u128)@u384 * 2**64 &&
  #//     r0@u384 + r1@u384 * 2**64 + (r2@u140 + c@u140)@u384 * 2**128 + r3@u384 * 2**192 = B0
  
  rax = *(uint64 *)(input_2 + 8)
  (uint128) rdx rax = rax * x1
  carry? r2 += rax
  rdx += 0 + carry
  carry? r2 += c
  c = 0
  c += rdx + carry

  #// var B1 = B0 + (input_1[8]@u128 * input_2[8]@u128)@u384 * 2**128
  #// cut r4 = 0 && r5 = 0 && x1 = input_1[8] &&
  #//     A0 = (input_1[0]@u128 * input_2[0]@u128)@u384 + (input_1[0]@u128 * input_2[8]@u128)@u384 * 2**64 + (input_1[0]@u128 * input_2[16]@u128)@u384 * 2**128 &&
  #//     B0 = A0 + (input_1[8]@u128 * input_2[0]@u128)@u384 * 2**64 && 
  #//     B1 = B0 + (input_1[8]@u128 * input_2[8]@u128)@u384 * 2**128 &&
  #//     r0@u384 + r1@u384 * 2**64 + r2@u384 * 2**128 + (r3@u140 + c@u140)@u384 * 2**192 = B1
  
  rax = *(uint64 *)(input_2 + 16)
  (uint128) rdx rax = rax * x1
  carry? r3 += rax 
  rdx += 0 + carry
  carry? r3 += c
  r4 += rdx + carry

  #// var B2 = B1 + (input_1[8]@u128 * input_2[16]@u128)@u384 * 2**192
  #// cut r5 = 0 &&
  #//     A0 = (input_1[0]@u128 * input_2[0]@u128)@u384 + (input_1[0]@u128 * input_2[8]@u128)@u384 * 2**64 + (input_1[0]@u128 * input_2[16]@u128)@u384 * 2**128 &&
  #//     B0 = A0 + (input_1[8]@u128 * input_2[0]@u128)@u384 * 2**64 && 
  #//     B1 = B0 + (input_1[8]@u128 * input_2[8]@u128)@u384 * 2**128 &&
  #//     B2 = B1 + (input_1[8]@u128 * input_2[16]@u128)@u384 * 2**192 &&
  #//     r0@u384 + r1@u384 * 2**64 + r2@u384 * 2**128 + r3@u384 * 2**192 + r4@u384 * 2**256 = B2

  #// var A1 = A0 +
  #//          (input_1[8]@u128 * input_2[0]@u128)@u384 * 2**64 + (input_1[8]@u128 * input_2[8]@u128)@u384 * 2**128 + (input_1[8]@u128 * input_2[16]@u128)@u384 * 2**192
  #// cut r5 = 0 &&
  #//     A0 = (input_1[0]@u128 * input_2[0]@u128)@u384 + (input_1[0]@u128 * input_2[8]@u128)@u384 * 2**64 + (input_1[0]@u128 * input_2[16]@u128)@u384 * 2**128 &&
  #//     A1 = A0 +
  #//          (input_1[8]@u128 * input_2[0]@u128)@u384 * 2**64 + (input_1[8]@u128 * input_2[8]@u128)@u384 * 2**128 + (input_1[8]@u128 * input_2[16]@u128)@u384 * 2**192 &&
  #//     r0@u384 + r1@u384 * 2**64 + r2@u384 * 2**128 + r3@u384 * 2**192 + r4@u384 * 2**256 = A1

  x2 = *(uint64 *)(input_1 + 16)
  rax = *(uint64 *)(input_2 + 0)
  (uint128) rdx rax = rax * x2
  carry? r2 += rax
  c = 0
  c += rdx + carry

  #// var C0 = A1 + (input_1[16]@u128 * input_2[0]@u128)@u384 * 2**128
  #// cut r5 = 0 && x2 = input_1[16] &&
  #//     A0 = (input_1[0]@u128 * input_2[0]@u128)@u384 + (input_1[0]@u128 * input_2[8]@u128)@u384 * 2**64 + (input_1[0]@u128 * input_2[16]@u128)@u384 * 2**128 &&
  #//     A1 = A0 +
  #//          (input_1[8]@u128 * input_2[0]@u128)@u384 * 2**64 + (input_1[8]@u128 * input_2[8]@u128)@u384 * 2**128 + (input_1[8]@u128 * input_2[16]@u128)@u384 * 2**192 &&
  #//     C0 = A1 + (input_1[16]@u128 * input_2[0]@u128)@u384 * 2**128 &&
  #//     r0@u384 + r1@u384 * 2**64 + r2@u384 * 2**128 + (r3@u140 + c@u140)@u384 * 2**192 + r4@u384 * 2**256 = C0
  
  rax = *(uint64 *)(input_2 + 8)
  (uint128) rdx rax = rax * x2
  carry? r3 += rax
  rdx += 0 + carry
  carry? r3 += c
  c = 0
  c += rdx + carry

  #// var C1 = C0 + (input_1[16]@u128 * input_2[8]@u128)@u384 * 2**192
  #// cut r5 = 0 && x2 = input_1[16] &&
  #//     A0 = (input_1[0]@u128 * input_2[0]@u128)@u384 + (input_1[0]@u128 * input_2[8]@u128)@u384 * 2**64 + (input_1[0]@u128 * input_2[16]@u128)@u384 * 2**128 &&
  #//     A1 = A0 +
  #//          (input_1[8]@u128 * input_2[0]@u128)@u384 * 2**64 + (input_1[8]@u128 * input_2[8]@u128)@u384 * 2**128 + (input_1[8]@u128 * input_2[16]@u128)@u384 * 2**192 &&
  #//     C0 = A1 + (input_1[16]@u128 * input_2[0]@u128)@u384 * 2**128 &&
  #//     C1 = C0 + (input_1[16]@u128 * input_2[8]@u128)@u384 * 2**192 &&
  #//     r0@u384 + r1@u384 * 2**64 + r2@u384 * 2**128 + r3@u384 * 2**192 + (r4@u140 + c@u140)@u384 * 2**256 = C1
  
  rax = *(uint64 *)(input_2 + 16)
  (uint128) rdx rax = rax * x2
  carry? r4 += rax
  rdx += 0 + carry
  carry? r4 += c
  r5 += rdx + carry

  #// var C2 = C1 + (input_1[16]@u128 * input_2[16]@u128)@u384 * 2**256
  #// cut A0 = (input_1[0]@u128 * input_2[0]@u128)@u384 + (input_1[0]@u128 * input_2[8]@u128)@u384 * 2**64 + (input_1[0]@u128 * input_2[16]@u128)@u384 * 2**128 &&
  #//     A1 = A0 +
  #//          (input_1[8]@u128 * input_2[0]@u128)@u384 * 2**64 + (input_1[8]@u128 * input_2[8]@u128)@u384 * 2**128 + (input_1[8]@u128 * input_2[16]@u128)@u384 * 2**192 &&
  #//     C0 = A1 + (input_1[16]@u128 * input_2[0]@u128)@u384 * 2**128 &&
  #//     C1 = C0 + (input_1[16]@u128 * input_2[8]@u128)@u384 * 2**192 &&
  #//     C2 = C1 + (input_1[16]@u128 * input_2[16]@u128)@u384 * 2**256 &&
  #//     r0@u384 + r1@u384 * 2**64 + r2@u384 * 2**128 + r3@u384 * 2**192 + r4@u384 * 2**256 + r5@u384 * 2**320 = C2

  #// var A2 = A1 +
  #//          (input_1[16]@u128 * input_2[0]@u128)@u384 * 2**128 + (input_1[16]@u128 * input_2[8]@u128)@u384 * 2**192 + (input_1[16]@u128 * input_2[16]@u128)@u384 * 2**256
  #// cut A0 = (input_1[0]@u128 * input_2[0]@u128)@u384 + (input_1[0]@u128 * input_2[8]@u128)@u384 * 2**64 + (input_1[0]@u128 * input_2[16]@u128)@u384 * 2**128 &&
  #//     A1 = A0 +
  #//          (input_1[8]@u128 * input_2[0]@u128)@u384 * 2**64 + (input_1[8]@u128 * input_2[8]@u128)@u384 * 2**128 + (input_1[8]@u128 * input_2[16]@u128)@u384 * 2**192 &&
  #//     A2 = A1 +
  #//          (input_1[16]@u128 * input_2[0]@u128)@u384 * 2**128 + (input_1[16]@u128 * input_2[8]@u128)@u384 * 2**192 + (input_1[16]@u128 * input_2[16]@u128)@u384 * 2**256 &&
  #//     r0@u384 + r1@u384 * 2**64 + r2@u384 * 2**128 + r3@u384 * 2**192 + r4@u384 * 2**256 + r5@u384 * 2**320 = A2

###################################################################
# The following should hold at this point:
#
# (x0 + 2^64*x1 + 2^128*x2) * (y0 + 2^64*x1 + 2^128*y2) = (r0 + 2^64*r1 + 2^128*r2 + 2^192*r3 + 2^256*r4 + 2^320*r5)
#
###################################################################

  #// cut true

  #// var r0_0 = r0
  #//     r1_0 = r1
  #//     r2_0 = r2
  #//     r3_0 = r3
  #//     r4_0 = r4
  #//     r5_0 = r5
  #//     r6_0 = r6

  rax = r3
  (uint128) rdx rax = rax * *(uint64 *)&_64_38
  
  r3 = rax
  rax = r4
  r4 = rdx
  
  (uint128) rdx rax = rax * *(uint64 *)&_64_38
  
  carry? r4 += rax
  rax = r5
  r5 = 0
  r5 += rdx + carry
  
  (uint128) rdx rax = rax * *(uint64 *)&_64_38
  
  carry? r5 += rax
  r6 = 0
  r6 += rdx + carry

  carry? r0 += r3
  carry? r1 += r4 + carry
  carry? r2 += r5 + carry
  
  zero = 0
  r6 += zero + carry

  #// var r0_1 = r0
  #//     r1_1 = r1
  #//     r2_1 = r2
  #//     r3_1 = r3
  #//     r4_1 = r4
  #//     r5_1 = r5
  #//     r6_1 = r6

  #// cut (r0_0@u140 + 38 * r3_0@u140)@u520 + (r1_0@u140 + 38 * r4_0@u140)@u520 * 2**64 + (r2_0@u140 + 38 * r5_0@u140)@u520 * 2**128 =
  #//     r0_1@u520 + r1_1@u520 * 2**64 + r2_1@u520 * 2**128 + r6_1@u520 * 2**192 &&
  #//     r0_1 = r0 &&
  #//     r1_1 = r1 &&
  #//     r2_1 = r2 &&
  #//     r3_1 = r3 &&
  #//     r4_1 = r4 &&
  #//     r5_1 = r5 &&
  #//     r6_1 = r6 &&
  #//     0 <=u r6 <u 2**6 &&
  #//     zero = 0

  r6 *= 38
  carry? r0 += r6
  carry? r1 += zero + carry
  carry? r2 += zero + carry

  #// var r0_2 = r0
  #//     r1_2 = r1
  #//     r2_2 = r2
  #//     r6_2 = r6

  #// cut (r0_1@u140 + 38 * r6_1@u140)@u520 + r1_1@u520 * 2**64 + r2_1@u520 * 2**128 =
  #//     r0_2@u520 + r1_2@u520 * 2**64 + r2_2@u520 * 2**128 + carry@u520 * 2**192 &&
  #//     r0_2 = r0 &&
  #//     r1_2 = r1 &&
  #//     r2_2 = r2 &&
  #//     r3_1 = r3 &&
  #//     r6_2 = r6 &&
  #//     0 <=u r6 <u 2**12 &&
  #//     zero = 0 &&
  #//     (carry = 1 || carry = 0)

  zero += zero + carry
  zero *= 38
  r0 += zero

  #// cut (r0_2@u140 + 38 * carry@u140)@u520 + r1_2@u520 * 2**64 + r2_2@u520 * 2**128 =
  #//     r0@u520 + r1@u520 * 2**64 + r2@u520 * 2**128

###################################################################
# The following should hold at this point:
#
# (x0 + 2^64*x1 + 2^128*x2) * (y0 + 2^64*x1 + 2^128*y2) congruent (r0 + 2^64*r1 + 2^128*r2) (modulo 2^191-19)
#
###################################################################
 
*(uint64 *)(input_0 + 8) = r1
*(uint64 *)(input_0 + 16) = r2
*(uint64 *)(input_0 + 0) = r0


#caller_r11 = caller_r11_stack
#caller_r12 = caller_r12_stack
#caller_r13 = caller_r13_stack
#caller_r14 = caller_r14_stack
#caller_r15 = caller_r15_stack
#caller_rbx = caller_rbx_stack
#caller_rbp = caller_rbp_stack

return
